
#include "64kedit.h"

// Initial size of segment. The edit window will allocate more
// if needed.

#define SEGMENT 16383 

extern PTWindowsObject CreationWindow;
extern PTWindowsObject DlgCreationWindow;
extern PTWindowsObject GetObjectPtr(HWND);

//************************************************
// This Create member function is based on the Create
// member function for TWindow. The difference is 
// the creation of a global memory segment for the
// edit controls memory and the removal of some MDI 
// stuff.
//************************************************

BOOL T64KEdit::Create()
{
    HWND 		HParent;
	WORD 		MenuOrId = 0;
	LPVOID		lpPtr;
	HANDLE 		heditds;
    HINSTANCE 	hinst;

	if (Status == 0) {
    	DisableAutoCreate();
    	if ( Parent == NULL )
			HParent = 0;
    	else
	   		HParent = Parent->HWindow;
		if ( !IsFlagSet(WB_FROMRESOURCE) ) {
			if ( Register() ) {
				CreationWindow = this;
				TWindowsObject *TmpDlgCreationWindow = DlgCreationWindow;
				/*  Set DlgCreationWindow to NULL so in InitWndProc we'll know
				we're not being created from a resource */
				DlgCreationWindow = NULL;
				MenuOrId = Attr.Id;
				// create global segment for edit control to use.
				heditds = GlobalAlloc(
							GMEM_DDESHARE | GMEM_MOVEABLE | GMEM_ZEROINIT,
							SEGMENT
						  );
				// if allocation fails then use the applications local heap
				if (heditds == NULL) {
					hinst = GetModule()->hInstance;
				} else { 
					lpPtr = GlobalLock(heditds);
					// Initialize a local heap in the segment
					LocalInit(HIWORD((LONG)lpPtr), 0, 
						(WORD)(GlobalSize(heditds) - 16));
					UnlockSegment(HIWORD((LONG)lpPtr));
					hinst = (HINSTANCE)HIWORD((LONG)lpPtr);
				}
				HWindow = CreateWindowEx(
								Attr.ExStyle, "edit",
								Title, Attr.Style, Attr.X, Attr.Y, Attr.W,
								Attr.H, HParent, (HMENU)MenuOrId , hinst,
								Attr.Param
						  );
				DlgCreationWindow = TmpDlgCreationWindow;
			}
		} else /* Windows already created window */
			HWindow = GetDlgItem(HParent, Attr.Id);
		if ( HWindow ) {
			if ( !GetObjectPtr(HWindow) ){ // predefined Windows class 
											// Retrieve the Title
				int TitleLength = GetWindowTextLength(HWindow);
				if (TitleLength > -1) {
					Title = (char far*)farmalloc((unsigned long)TitleLength + 1);
					Title[0] = '\0'; Title[TitleLength] = '\0';
					GetWindowText(HWindow, Title, TitleLength+1);
				} else
					Title = _fstrdup("");
				if ( IsFlagSet(WB_FROMRESOURCE) ) {
					Attr.Style = GetWindowLong(HWindow, GWL_STYLE);
					Attr.ExStyle = GetWindowLong(HWindow, GWL_EXSTYLE);
				}
				// Retrieve Attr.X, Attr.Y, Attr.W and Attr.H
				RECT WndRect;
				GetWindowRect(HWindow, &WndRect);
				Attr.H = WndRect.bottom - WndRect.top;
				Attr.W = WndRect.right - WndRect.left;
				if ( HParent && ((Attr.Style & WS_CHILD) == WS_CHILD) )
					ScreenToClient(HParent, (LPPOINT)&WndRect);
				Attr.X = WndRect.left;
				Attr.Y = WndRect.top;
				SetFlags(WB_PREDEFINEDCLASS, TRUE);
				DefaultProc =  (WNDPROC)SetWindowLong(HWindow, GWL_WNDPROC,
										(DWORD)GetInstance());
				SetupWindow();
			}
		} else {                             // HWindow == 0
			if ( Attr.Menu )
				DestroyMenu( HMENU( MenuOrId ));
			Status = EM_INVALIDWINDOW;
		}
	}
	return (Status == 0);
}

